//NameHKScriptMenu::QR_trace

#target Illustrator
var doc = app.activeDocument;
var tolerance = 0.5;
var res = 1200;
var rasterizeOptions = new RasterizeOptions;  
  rasterizeOptions.antiAliasingMethod = AntiAliasingMethod.None;  
  rasterizeOptions.clippingMask = false;  
  rasterizeOptions.colorModel = RasterizationColorModel.GRAYSCALE;  
  rasterizeOptions.resolution = res;  
  rasterizeOptions.transparency = true;  
  
var ar = doc.artboards[0].artboardRect;
if (doc.selection[0].typename != "PathItem" && doc.selection[0].length != 1) {
	var actAB =  doc.artboards.getActiveArtboardIndex();
	doc.artboards.setActiveArtboardIndex(0);
	app.executeMenuCommand('Fit Artboard to selected Art');
	var gb = doc.artboards[0].artboardRect;
	doc.selection = false;
	var clipRect = doc.pathItems.rectangle (gb[1], gb[0], (gb[2]-gb[0]), (gb[1]-gb[3]));
	var noColor = new NoColor();
	clipRect.strokeColor = noColor;
	clipRect.fillColor = noColor;
	var lockedItems = [];
	saveLockedItems(doc.pageItems);
	app.executeMenuCommand('selectallinartboard');
	doc.artboards[0].artboardRect = ar;
	doc.artboards.setActiveArtboardIndex(actAB);
} else {
	var clipRect = doc.selection[0];
	var gb = clipRect.geometricBounds;
	doc.artboards[0].artboardRect = gb;
	var lockedItems = [];
	saveLockedItems(doc.pageItems);
	app.executeMenuCommand('selectallinartboard');
	doc.artboards[0].artboardRect = ar;
};
clipRect.selected = false;
var obj = [];
for (var i = 0; i < doc.selection.length; i++) {
	obj[i] = doc.selection[i];
};
doc.selection = false;
var tempLayer = doc.layers.add(); 
var qrClipGroup = doc.groupItems.add();
for (p=obj.length-1;p>=0;p--) {
	obj[p].duplicate(qrClipGroup);
};
clipRect.moveToBeginning(qrClipGroup);
qrClipGroup.clipped = true;
restoreLockedItems();
var imgQR = doc.rasterize(qrClipGroup, gb, rasterizeOptions);
var Tracing_Preset = 'Black and White Logo'; 
var pic = imgQR.trace();
pic.tracing.tracingOptions.loadFromPreset(Tracing_Preset);   
pic.tracing.expandTracing().selected = true;
executeMenuCommand('Add Anchor Points2');
var arrAnchor = [];
var QRGroup = tempLayer.groupItems[0];
clearWhiteItems (QRGroup);
var QRItems = getQRItems(QRGroup);
var qrPaths = QRItems[0];
for (var p=qrPaths.length-1;p>=0;p--) {
		obj=qrPaths[p];
	//try {
	for (var i=0;i<obj.pathPoints.length;i++) {
		arrAnchor.push(obj.pathPoints[i].anchor);
	};
	//} catch (e) {};
};
var refWidth = QRGroup.width;
var rt = arrAnchor.sort(function(a, b) {return b[1] - a[1];})[0];
var lb = arrAnchor.sort(function(a, b) { return a[0] - b[0];})[0];
var angleQR = angle(lb[0], lb[1], rt[0], rt[1]);
QRGroup.rotate(-angleQR);
var qrWidth = QRGroup.width;
var wasRotated = qrWidth < refWidth;
if (!wasRotated) {QRGroup.rotate(angleQR);}
var qrPos = QRGroup.position;
qrWidth = QRGroup.width;
QRGroup.height = qrWidth;
 //var pi = tempLayer.groupItems[0].pageItems.slice();
var pi = [];
for (var j=0;j<QRGroup.pageItems.length;j++) {
	pi.push(QRGroup.pageItems[j]);
};
var QRBitDepth = getQRBitDepth (pi, qrWidth);
//alert (QRBitDepth)
QRGroup.width = QRBitDepth;
QRGroup.height = QRBitDepth;
QRGroup.position = [0,0];
var ap = new Array();
for (var j=0;j<QRItems[0].length;j++) {
	obj=QRItems[0][j];
		for (var i=0;i<obj.pathPoints.length;i++) {
			ap[0]=Math.round(obj.pathPoints[i].anchor[0]);
			ap[1]=Math.round(obj.pathPoints[i].anchor[1]);
			obj.pathPoints[i].anchor = ap;
			obj.pathPoints[i].leftDirection = ap;
			obj.pathPoints[i].rightDirection = ap;
		};
};
app.executeMenuCommand('Live Pathfinder Exclude');
app.executeMenuCommand('expandStyle');
QRGroup.width = qrWidth;
QRGroup.height = qrWidth;
QRGroup.position = qrPos;
if (wasRotated) {QRGroup.rotate(angleQR);}
try { 
	var QR_Regenerate = doc.layers.getByName("QR_Regenerate");
	QRGroup.move(QR_Regenerate, ElementPlacement.INSIDE);
	tempLayer.remove();
} catch (e) { tempLayer.name = "QR_Regenerate" }

//==================================================================================================
function getQRBitDepth (objects, w) {
	var arrPointSize = [], pointSize = 0;
	//doc.selection = false;
	var nomPosLabels = getNomPosLabels (objects);
	for (var i=0;i<nomPosLabels.length;i++) {
		//nomPosLabels[i].selected = true
		wpointSize = nomPosLabels[i].pathItems[1].width/7;
		hpointSize = nomPosLabels[i].pathItems[1].height/7;
		thL = nomPosLabels[i].pathItems[0].geometricBounds[0] - nomPosLabels[i].pathItems[1].geometricBounds[0];
		thT = nomPosLabels[i].pathItems[1].geometricBounds[1] - nomPosLabels[i].pathItems[0].geometricBounds[1];
		thR = nomPosLabels[i].pathItems[1].geometricBounds[2] - nomPosLabels[i].pathItems[0].geometricBounds[2];
		thB = nomPosLabels[i].pathItems[0].geometricBounds[3] - nomPosLabels[i].pathItems[1].geometricBounds[3];
		//if (Math.max(thL, thT, thR, thB) < wpointSize + wpointSize * tolerance && Math.abs(nomPosLabels[i].pathItems[1].width - nomPosLabels[i].pathItems[1].height) < wpointSize * tolerance ) {
		if (Math.max(thL, thT, thR, thB) < wpointSize + wpointSize * tolerance && Math.abs(nomPosLabels[i].width - nomPosLabels[i].height) < wpointSize * tolerance && Math.abs(nomPosLabels[i].pathItems[1].width - nomPosLabels[i].pathItems[1].height) < wpointSize * tolerance) {
		//if (Math.max(thL, thT, thR, thB) < wpointSize + wpointSize * tolerance ) {
			arrPointSize.push(hpointSize);
		};
	};
	//alert (arrPointSize.length)
	if (arrPointSize.length == 3) {
		for (var i=0;i<arrPointSize.length;i++) {
			pointSize += arrPointSize[i];
		};
		pointSize = pointSize/3;
		var BitDepth = w/pointSize;
		BitDepth = Math.round((BitDepth - 17)/4)*4+17;
	return BitDepth;
	}
}

function getNomPosLabels (objects) {
	var npl = [];
	objects.sort(function (a, b) {return (a.width - b.width || a.height - b.height)});
	objects.sort(function (a, b) {return (Math.round((b.geometricBounds[1] - a.geometricBounds[1])) || Math.round((a.geometricBounds[0] - b.geometricBounds[0])))});
	if (objects[0].typename == "CompoundPathItem") npl.push(objects[0]);
	objects.sort(function (a, b) {return (a.width - b.width || a.height - b.height)});
	objects.sort(function (a, b) {return (Math.round((b.geometricBounds[1] - a.geometricBounds[1])) || Math.round((b.geometricBounds[2] - a.geometricBounds[2])))});
	if (objects[0].typename == "CompoundPathItem") npl.push(objects[0]);
	objects.sort(function (a, b) {return (a.width - b.width || a.height - b.height)});
	objects.sort(function (a, b) {return (Math.round((a.geometricBounds[0] - b.geometricBounds[0])) || Math.round((a.geometricBounds[3] - b.geometricBounds[3])))});
	if (objects[0].typename == "CompoundPathItem") npl.push(objects[0]);
	objects.sort(function (a, b) {return (a.width - b.width || a.height - b.height)});
	objects.sort(function (a, b) {return (Math.round((b.geometricBounds[2] - a.geometricBounds[2])) || Math.round((a.geometricBounds[3] - b.geometricBounds[3])))});
	if (objects[0].typename == "CompoundPathItem") npl.push(objects[0]);
	return npl;
};

function getQRItems (obj) {
	var arrQRPath = [], arrQRCompoundPath = [];
	var qrItems = obj.pageItems;
	for (var i=0;i<qrItems.length;i++) {
		if (qrItems[i].typename == "CompoundPathItem") {
			arrQRCompoundPath.push(qrItems[i]);
			for (var c=0;c<qrItems[i].pathItems.length;c++) {
				arrQRPath.push(qrItems[i].pathItems[c]);
			};
		};
		if (qrItems[i].typename == "PathItem") {
			arrQRPath.push(qrItems[i]);
		};
	};
	return [arrQRPath, arrQRCompoundPath];
};

function clearWhiteItems (obj) {
	var qrItems = obj.pageItems.slice();
	for (var p=qrItems.length-1;p>=0;p--) {
		try {
			if (qrItems[p].pathItems[0].fillColor.gray == 0) {
				qrItems[p].remove();
			};
		} catch (e) {if (qrItems[p].fillColor.gray == 0) qrItems[p].remove()};
	};
};

function saveLockedItems (items) {
    var li = [];
        n = items.length;
    while (n--) {
                if (items[n].locked) {
                    li.push(items[n]);
                    items[n].locked = false;
                };
            };
    lockedItems = lockedItems.concat(li);
};

function restoreLockedItems() {
    var i = lockedItems.length;
    while (i--) lockedItems[i].locked = true;
};

function angle(cx, cy, ex, ey) {
  var dy = ey - cy;
  var dx = ex - cx;
  var theta = Math.atan2(dy, dx); 
  theta *= 180 / Math.PI; 
  return theta;
};

function clearWhiteItems (group) {
	var qrItems = tempLayer.groupItems[0].pageItems;
	for (p=qrItems.length-1;p>=0;p--) {
		try {
			if (qrItems[p].pathItems[0].fillColor.gray == 0) {
				qrItems[p].remove();
			};
		} catch (e) {try {if (qrItems[p].fillColor.gray == 0) qrItems[p].remove()} catch (e) {}};
	};
};
